//+------------------------------------------------------------------+
//|                                                          CCI.mq4 |
//+------------------------------------------------------------------+
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property  indicator_minimum -350
#property  indicator_maximum  350

extern int CCIPeriod=14;
extern int TimeFrame=0;  //1=M1;5=M5;15=M15;30=M30;60=H1;240=H4;1440=D1; 
//---- indicator buffers
double CCIupBuffer[],
       CCIdnBuffer[];
//---- indicator levels
double level[7]= {300, 200, 100, 0, -100, -200, -300};
//---- indicator colors
color  cDirection[2]={LimeGreen,FireBrick};
string sDirection[2]={"up", "down"};
string TimeFrameStr;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetLevelStyle(STYLE_DOT,1,LightSlateGray); 
   for(int l=0;l<=6;l++){SetLevelValue(l,level[l]);} 
   IndicatorDigits(0);
   int bars=WindowBarsPerChart();
   int width;
   for(int i=0;i<=5;i++){
   int brs[6]={800, 400, 200, 100, 50, 25};
   int wdt[6]={1, 2, 3, 5, 8, 13}; 
   if(bars<=brs[i]) width=wdt[i];}
   for(i=0;i<=1;i++){
   SetIndexStyle(i,DRAW_HISTOGRAM,STYLE_SOLID,width,cDirection[i]);
   SetIndexDrawBegin(i,CCIPeriod);
   SetIndexLabel(i,sDirection[i]);}
//---- 2 indicator buffers mapping
   SetIndexBuffer(0,CCIupBuffer);
   SetIndexBuffer(1,CCIdnBuffer);
//---- name for DataWindow and indicator subwindow label
   switch(TimeFrame)
     {
      case 1 : TimeFrameStr="M1"; break;
      case 5 : TimeFrameStr="M5"; break;
      case 15 : TimeFrameStr="M15"; break;
      case 30 : TimeFrameStr="M30"; break;
      case 60 : TimeFrameStr="H1"; break;
      case 240 : TimeFrameStr="H4"; break;
      case 1440 : TimeFrameStr="D1"; break;
      case 10080 : TimeFrameStr="W1"; break;
      case 43200 : TimeFrameStr="MN1"; break;
      default : TimeFrameStr="";
     }
   IndicatorShortName("CCI "+TimeFrameStr+" ("+CCIPeriod+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Commodity Channel Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   double   prev,curr;
   bool     up=true;
   double   zero=50;
   int bars_count=WindowBarsPerChart();
   int bar=WindowFirstVisibleBar();

   for(int i=0; i<bars_count; i++,bar--)     
     {// time frames to use
      int  shift = iBarShift(NULL,TimeFrame,Time[i]);
     // setup indies for tf
      curr=iCCI(NULL,TimeFrame,CCIPeriod,PRICE_CLOSE,shift)+zero;
      prev=iCCI(NULL,TimeFrame,CCIPeriod,PRICE_CLOSE,shift+1)+zero;
      
      if(curr>level[3] && curr>=prev) up=true;
      if(curr<level[1] && curr<=prev) up=false;
      if(!up)
        {CCIdnBuffer[i]=curr;
         CCIupBuffer[i]=0.0;}
      else
        {CCIupBuffer[i]=curr;
         CCIdnBuffer[i]=0.0;}
     }
//---- done
   return(0);
  }